package com.ekexiu.project.platform.article;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.web.annotation.LoginUser;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.util.auth.AuthUser;
import org.jfw.util.jdbc.JdbcUtil;
import org.jfw.util.jdbc.PreparedStatementConfig;

@Path("/article")
public class ArticleService {

	@Autowrie

	private ArticleDao articleDao;

	public ArticleDao getArticleDao() {
		return articleDao;
	}

	public void setArticleDao(ArticleDao articleDao) {
		this.articleDao = articleDao;
	}

	@Path("/invalid")
	@Post
	public int invalid(@JdbcConn(true) Connection con, final String id, final @LoginUser AuthUser user) throws SQLException {
		if (articleDao.invalid(con, id) != 0) {
			JdbcUtil.execute(con, "INSERT INVALID_ARTICLE (ID,TITLE,CREATOR,CREATE_TIME,INVALID_TIME,INVALID_OPERATOR) "
					+ "SELECT ID,TITLE,CREATOR,CREATE_TIME,TO_CHAR(NOW(),'YYYYMMDDHH24MISS'),? FROM ARTICLE WHERE ID=?", new PreparedStatementConfig() {
						@Override
						public void config(PreparedStatement ps) throws SQLException {
							ps.setString(1, user.getId());
							ps.setString(2, id);

						}
					});
			return 1;
		}
		return 0;
	}
	
	@LoginUser
	@Path("/valid")
	@Post
	public int valid(@JdbcConn(true) Connection con, final String id) throws SQLException {
		if(articleDao.valid(con, id)!=0){
			articleDao.delete(con, id);
			return 1;
		}
		return 0;
	}
}
