package com.ekexiu.project.platform.system.service;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.Random;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.LoginUser;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.method.InvalidSession;
import org.jfw.apt.web.annotation.method.ResultToNull;
import org.jfw.apt.web.annotation.method.SetSession;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.operate.Put;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.apt.web.annotation.param.PathVar;
import org.jfw.apt.web.annotation.param.RequestBody;
import org.jfw.apt.web.annotation.param.RequestParam;
import org.jfw.apt.web.annotation.param.SessionVal;
import org.jfw.util.DateUtil;
import org.jfw.util.StringUtil;
import org.jfw.util.auth.AuthUser;
import org.jfw.util.context.JfwAppContext;
import org.jfw.util.exception.JfwBaseException;
import org.jfw.util.jdbc.JdbcUtil;

import com.ekexiu.project.platform.mobile.MobilePhoneService;
import com.ekexiu.project.platform.system.dao.UserDao;
import com.ekexiu.project.platform.system.po.Manager;
import com.ekexiu.project.platform.system.po.SysRight;
import com.ekexiu.project.platform.system.po.User;
import com.ekexiu.project.platform.system.po.UserLoginLog;
import com.ekexiu.project.platform.system.vo.ManagerInfo;
import com.ekexiu.project.platform.system.vo.SessionUser;

@Path("/sys")
public class SysService {

	private String regMobilePhoneReplaceKey = "yzm";
	private String regMobilePhoneContentTemplate = "【声脉】您的验证码为yzm，请于3分钟内正确输入，如非本人操作，请忽略此短信。";
	private long timeLimitWithRegMobilePhone = 3 * 60 * 1000;
	
	
	private String fixRightCode="aaa";
	
	
	
	
	private String accountPrefix = "xtpt_";

	@Autowrie
	private UserDao userDao;

	@Autowrie
	private MobilePhoneService mobilePhoneService;

	public UserDao getUserDao() {
		return userDao;
	}

	public void setUserDao(UserDao userDao) {
		this.userDao = userDao;
	}

	public MobilePhoneService getMobilePhoneService() {
		return mobilePhoneService;
	}

	public void setMobilePhoneService(MobilePhoneService mobilePhoneService) {
		this.mobilePhoneService = mobilePhoneService;
	}

	public String getRegMobilePhoneReplaceKey() {
		return regMobilePhoneReplaceKey;
	}

	public void setRegMobilePhoneReplaceKey(String regMobilePhoneReplaceKey) {
		this.regMobilePhoneReplaceKey = regMobilePhoneReplaceKey;
	}

	public String getRegMobilePhoneContentTemplate() {
		return regMobilePhoneContentTemplate;
	}

	public void setRegMobilePhoneContentTemplate(String regMobilePhoneContentTemplate) {
		this.regMobilePhoneContentTemplate = regMobilePhoneContentTemplate;
	}

	public long getTimeLimitWithRegMobilePhone() {
		return timeLimitWithRegMobilePhone;
	}

	public void setTimeLimitWithRegMobilePhone(long timeLimitWithRegMobilePhone) {
		this.timeLimitWithRegMobilePhone = timeLimitWithRegMobilePhone;
	}

	public String getAccountPrefix() {
		return accountPrefix;
	}

	public void setAccountPrefix(String accountPrefix) {
		this.accountPrefix = accountPrefix;
	}

	@SetSession("JFW_SESSION_LOGIN_USER=result")
	@Path("/login")
	@Post
	public SessionUser login(@JdbcConn Connection con, String phone, String pw) throws SQLException, JfwBaseException {
		final User user = userDao.queryByLoginPhone(con, phone, null);
		if (user != null) {
			if (!user.isActive()) {
				throw new JfwBaseException(-60003, "user is disabled");
			}
			if (StringUtil.md5(pw).equals(user.getPasswd())) {
				JfwAppContext.getScheduledExecutorService().submit(new Runnable() {

					@Override
					public void run() {
						try {
							Connection conn = JfwAppContext.getDataSource().getConnection();
							try {
								userDao.updateLoginLog(conn, user.getId(), DateUtil.formatDateTime(System.currentTimeMillis()));
								conn.commit();
							} catch (SQLException ee) {
								JdbcUtil.rollback(conn);
							} finally {
								JdbcUtil.close(conn);
							}
						} catch (Exception e) {

						}
					}

				});
				return makeSessionUser(user);
			}
			throw new JfwBaseException(-60002, "invalid passwd");
		} else {
			throw new JfwBaseException(-60001, "user not exists");
		}
	}

	@Get
	@Path("/user")
	public SessionUser get(@LoginUser(false) SessionUser user) {
		return user;
	}

	@Post
	@Path("/user")
	public void modifyUser(@JdbcConn(true) Connection con,@LoginUser SessionUser loginUser,
			@RequestParam(excludeFields={"id","createTime","modifyTime","loginPhone","passwd","active"}) User user)throws SQLException{
		user.setId(loginUser.getId());
		userDao.update(con, user);
	}
	
	@Post
	@Path("/user/changepasswd")
	public int changePasswd(@JdbcConn(true) Connection con,@LoginUser SessionUser loginUser,String opw,String npw)throws SQLException{
		return userDao.changePasswd(con,loginUser.getId(), StringUtil.md5(opw),StringUtil.md5(npw));
	}

	@Get
	@Path("/logout")
	@InvalidSession
	public void logout() {
	}

	@Get
	@Path("/serviceTime")
	public long serviceTime() {
		return System.currentTimeMillis();
	}

	@Get
	@Path("/user/exists")
	public boolean existsUser(@JdbcConn Connection con, String phone, @Nullable Boolean active) throws SQLException {
		return null != userDao.queryByLoginPhone(con, phone, active);
	}

	@SetSession({ "REG_PHONE=result[0]", "REG_PHONE_VC=result[1]", "REG_PHONE_TIMEOUT=result[1]" })
	@ResultToNull
	@Get
	@Post
	@Path("/registe/phone/msg")
	public Object[] registePhoneMsg(String phone, String vc, @Nullable @SessionVal(value = "PIC_REG", remove = true) String code,
			@Nullable @SessionVal(value = "TIMEOUT_PIC_REG", remove = true) Long timeout) throws Exception {
		if (code == null || timeout == null || System.currentTimeMillis() > timeout ) {
			throw new JfwBaseException(-60001, "not found sessionVal");
		}
		if (!vc.equals(code)) {
			throw new JfwBaseException(-60003, "vc not right");
		}
		Random rd = new Random();
		int vi = rd.nextInt(10000);
		String vcode = String.format("%04d", vi);

		this.mobilePhoneService.sendMessage(phone, this.regMobilePhoneContentTemplate, this.regMobilePhoneReplaceKey, vcode);
		Object[] result = new Object[3];
		result[0] = phone;
		result[1] = vcode;
		result[2] = System.currentTimeMillis() + 5000 + timeLimitWithRegMobilePhone;
		return result;
	}
	
	
	
	@SetSession({ "RSP_PHONE=result[0]", "RSP_PHONE_VC=result[1]", "RSP_PHONE_TIMEOUT=result[1]" })
	@ResultToNull
	@Get
	@Post
	@Path("/resetpw/phone/msg")
	public Object[] resetpwPhoneMsg(@JdbcConn Connection con, String phone) throws Exception {
		if( null == userDao.queryByLoginPhone(con, phone, null)){
			throw new JfwBaseException(-60001, "invalid phone num");
		}
		Random rd = new Random();
		int vi = rd.nextInt(10000);
		String vcode = String.format("%04d", vi);
		this.mobilePhoneService.sendMessage(phone, this.regMobilePhoneContentTemplate, this.regMobilePhoneReplaceKey, vcode);
		Object[] result = new Object[3];
		result[0] = phone;
		result[1] = vcode;
		result[2] = System.currentTimeMillis() + 5000 + timeLimitWithRegMobilePhone;
		return result;
	}
	@Get
	@Path("/resetpw/phone/msgCheck")
	public boolean resetpwPhoneMsgCheck(String phone, String vc, @Nullable @SessionVal(value = "RSP_PHONE") String sPhone,
			@Nullable @SessionVal(value = "RSP_PHONE_VC") String sCode, @Nullable @SessionVal(value = "RSP_PHONE_TIMEOUT") Long timeout) throws Exception {
		if (sCode == null || timeout == null || System.currentTimeMillis() > timeout) {
			throw new JfwBaseException(-60001, "not found sessionVal");
		}
		return vc.equals(sCode) && phone.equals(sPhone);
	}
	
	
	
	
	
	

	@Get
	@Path("/registe/phone/msgCheck")
	public boolean registePhoneMsgCheck(String phone, String vc, @Nullable @SessionVal(value = "REG_PHONE") String sPhone,
			@Nullable @SessionVal(value = "REG_PHONE_VC") String sCode, @Nullable @SessionVal(value = "REG_PHONE_TIMEOUT") Long timeout) throws Exception {
		if (sCode == null || timeout == null || System.currentTimeMillis() > timeout) {
			throw new JfwBaseException(-60001, "timeout");
		}
		return vc.equals(sCode) && phone.equals(sPhone);
	}

	@Post
	@Path("/registe")
	public void registe(@JdbcConn(true) Connection con, @Nullable String head, String phone, String vc, String pw,
			@Nullable @SessionVal(value = "REG_PHONE", remove = true) String sPhone, @Nullable @SessionVal(value = "REG_PHONE_VC", remove = true) String sCode,
			@Nullable @SessionVal(value = "REG_PHONE_TIMEOUT", remove = true) Long timeout) throws Exception {
		if (sCode == null || timeout == null || System.currentTimeMillis() > timeout) {
			throw new JfwBaseException(-60001, "timeout");
		}
		if (!vc.equals(sCode) || !phone.equals(sPhone)) {
			throw new JfwBaseException(-60002, "invalid");
		}
		User user = userDao.queryByLoginPhone(con, phone, null);
		if (user != null) {
			throw new JfwBaseException(-60003, "phone num exists");
		}
		Random rd = new Random();
		user = new User();
		user.setId(StringUtil.buildUUID());
		user.setAccount(this.accountPrefix + String.format("%08d", rd.nextInt(100000000)));
		user.setActive(true);
		user.setHead(head);
		user.setLinkPhone(phone);
		user.setPasswd(StringUtil.md5(pw));
		userDao.insert(con, user);
		UserLoginLog uli = new UserLoginLog();
		uli.setId(user.getId());
		uli.setLastLoginTime(DateUtil.formatDateTime(System.currentTimeMillis()));
	}
	
	@Post
	@Path("/resetpw")
	@InvalidSession
	public void resetpw(@JdbcConn(true) Connection con, String phone, String vc, String pw,
			@Nullable @SessionVal(value = "RSP_PHONE", remove = true) String sPhone, @Nullable @SessionVal(value = "RSP_PHONE_VC", remove = true) String sCode,
			@Nullable @SessionVal(value = "RSP_PHONE_TIMEOUT", remove = true) Long timeout) throws Exception {
		if (sCode == null || timeout == null || System.currentTimeMillis() > timeout) {
			throw new JfwBaseException(-60001, "timeout");
		}
		if (!vc.equals(sCode) || !phone.equals(sPhone)) {
			throw new JfwBaseException(-60002, "invalid valid code");
		}
		if(0 == userDao.resetPasswd(con, phone, pw)){
			throw new JfwBaseException(-60003, "no found data");
		}
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	@Path("/user/new")
	@Post
	public String addUser(@JdbcConn(true) Connection con , @LoginUser AuthUser au, @RequestParam(excludeFields={"id","acitve","createor"}) Manager user,String[] rightCode)throws SQLException{
		String id = StringUtil.buildUUID();
		user.setActive(true);
		user.setCreator(au.getId());
		user.setId(id);
		user.setInvalidOperator(null);
		user.setInvalidTime(null);
		user.setPasswd(StringUtil.md5("123456"));
		userDao.insert(con, user);
		if(rightCode != null && rightCode.length >0){
			SysRight rights[]  = new SysRight[rightCode.length];
			for(int i = 0; i < rightCode.length;++i){
				rights[i] = new SysRight();
				rights[i].setUid(id);
				rights[i].setRightCode(rightCode[i]);
			}
			userDao.insert(con, rights);
		}
		return id;
	}
	
	@Path("/user/renew")
	@Put
	public void renewUser(@JdbcConn(true) Connection con , @LoginUser AuthUser au, @RequestBody ManagerInfo user)throws SQLException{
		user.setModifier(au.getId());
		userDao.update(con, user);
		userDao.delete(con,user.getId(),this.fixRightCode);
		String[] rightCode = user.getRightCode();
		if(rightCode != null && rightCode.length >0){
			SysRight rights[]  = new SysRight[rightCode.length];
			for(int i = 0; i < rightCode.length;++i){
				rights[i] = new SysRight();
				rights[i].setUid(user.getId());
				rights[i].setRightCode(rightCode[i]);
			}
			userDao.insert(con, rights);
		}
	}
	
	@Path("/user/right/{uid}")
	@Put
	public void rightUser(@JdbcConn(true) Connection con , @LoginUser AuthUser au,@PathVar String uid, @RequestBody String[] rightCode)throws SQLException{
		userDao.delete(con,uid,this.fixRightCode);
		if(rightCode != null && rightCode.length >0){
			SysRight rights[]  = new SysRight[rightCode.length];
			for(int i = 0; i < rightCode.length;++i){
				rights[i] = new SysRight();
				rights[i].setUid(uid);
				rights[i].setRightCode(rightCode[i]);
			}
			userDao.insert(con, rights);
		}
	}
	
	

	private static SessionUser makeSessionUser(User user) {
		SessionUser sessionUser = new SessionUser();
		sessionUser.setAccount(user.getAccount());
		sessionUser.setComp(user.getComp());
		sessionUser.setEmail(user.getEmail());
		sessionUser.setId(user.getId());
		sessionUser.setJob(user.getJob());
		sessionUser.setName(user.getName());
		sessionUser.setActive(user.isActive());
		sessionUser.setAddr(user.getAccount());
		sessionUser.setCreateTime(user.getCreateTime());
		sessionUser.setHead(user.getHead());
		sessionUser.setLinkPhone(user.getLinkPhone());
		sessionUser.setLoginPhone(user.getLoginPhone());
		sessionUser.setModifyTime(user.getModifyTime());
		sessionUser.setSex(user.getSex());
		return sessionUser;
	}
}
